Index: trunk/debian/rules
===================================================================
--- trunk/debian/rules	(revision 90037)
+++ trunk/debian/rules	(revision 90038)
@@ -29,5 +29,5 @@
 #                   either the subversion rev [if available] or the build date)
 #  NODOCS=1         don't build docs, use precompiled UserManual.pdf and
-#                   maybe VirtualBox.chm from $(vboxroot)/prebuild
+#                   maybe VirtualBox.qch and VirtualBox.qhc from $(vboxroot)/prebuild
 #  NOMODS=1         don't build any module
 #  NOQT=1           don't build the Qt GUI
@@ -38,11 +38,12 @@
 #  NOWEBSVC=1       don't build the webservice API, default for OSE
 #  STAGEDISO=<path> don't build the VBoxAdditions, use the precompiled .iso
-#  STAGEDCHM=<path> use VirtualBox*.chm from this directory
+#  STAGEDQHELP=<path> use VirtualBox*.qch and VirtualBox*.qhc from this directory
 #  PKGDIR=<path>    where to store the final package(s)
 #
 # NODOCS will be set if UserManual*.pdf is placed in $(vboxroot)/prebuild.
 # STAGEDISO will be set if VBoxGuestAdditions.iso is placed there.
-# STAGEDCHM will be set if VirtualBox*.chm is placed there.
-# VirtualBox*.chm is used if it is provided, but never attempted to be built.
+# STAGEDQHELP will be set if VirtualBox*.qch and VirtualBox*.qhc is placed there.
+# VirtualBox*.qch and VirtualBox*.qhc are used if they are provided, but never
+# attempted to be built.
 #
 # Wine will not be required if either NODOCS or STAGEDISO are set.
@@ -66,5 +67,5 @@
 NODOCS   ?= $(if $(wildcard $(vboxroot)/prebuild/UserManual*.pdf),1,)
 STAGEDISO ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxGuestAdditions.iso),$(vboxroot)/prebuild,)
-STAGEDCHM ?= $(if $(wildcard $(vboxroot)/prebuild/VirtualBox*.chm),$(vboxroot)/prebuild,)
+STAGEDQHELP ?= $(if $(and $(wildcard $(vboxroot)/prebuild/VirtualBox*.qch),$(wildcard $(vboxroot)/prebuild/VirtualBox*.qhc)),$(vboxroot)/prebuild,)
 NOWINE   := $(if $(NODOCS),1,$(if $(STAGEDISO),1,$(ose)))
 PYTHON   := $(firstword $(shell which python) $(shell which python3))
@@ -102,5 +103,5 @@
 	     VBOX_DO_STRIP= \
 	     VBOX_PATH_PACKAGE_DOCS="\"/usr/share/doc/$(verpkg)\"" \
-	     $(if $(STAGEDCHM),VBOX_WITH_DOCS_CHM=1,VBOX_WITH_KCHMVIEWER=) \
+	     $(if $(STAGEDQHELP),VBOX_WITH_DOCS_QHELP=1,) \
 	     $(if $(svnrev),VBOX_SVN_REV=$(svnrev),) \
 	     $(if $(NODOCS),VBOX_WITH_DOCS= ,) \
@@ -119,5 +120,5 @@
 	. debian/env.sh && kmk -C $(vboxroot) $(bld_flags) $(if $(NOPARALLEL),-j1,) all
 	$(if $(NODOCS),cp $(vboxroot)/prebuild/UserManual*.pdf $(builddir)/bin,)
-	$(if $(STAGEDCHM),cp $(STAGEDCHM)/VirtualBox*.chm $(builddir)/bin,)
+	$(if $(STAGEDQHELP),cp $(STAGEDQHELP)/VirtualBox*.qch $(STAGEDQHELP)/VirtualBox*.qhc $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI32.fd $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI64.fd $(builddir)/bin,)
@@ -236,7 +237,7 @@
 ifeq ($(ose),)
 	dh_installdocs \
-	    $(archdir)/UserManual*.pdf $(archdir)/VirtualBox*.chm \
-	    $(addprefix $(archdir)/, LICENSE)
-	rm $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.chm \
+	    $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.qch VirtualBox*.qhc \
+	    LICENSE)
+	rm $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.qch VirtualBox*.qhc \
 	    LICENSE)
 	for i in rdesktop-vrdp.tar.gz additions/VBoxGuestAdditions.iso; do \
@@ -307,5 +308,5 @@
 endif
 	$(firstword $(shell which dh_python2) $(shell which dh_python3))
-	dh_compress -X.pdf -X.chm -X LICENSE -X.py
+	dh_compress -X.pdf -X LICENSE -X.py
 	dh_fixperms
 	dh_makeshlibs
Index: trunk/src/VBox/Installer/linux/debian/rules
===================================================================
--- trunk/src/VBox/Installer/linux/debian/rules	(revision 90037)
+++ trunk/src/VBox/Installer/linux/debian/rules	(revision 90038)
@@ -34,5 +34,5 @@
 #                   either the subversion rev [if available] or the build date)
 #  NODOCS=1         don't build docs, use precompiled UserManual.pdf and
-#                   maybe VirtualBox.chm from $(vboxroot)/prebuild
+#                   maybe VirtualBox.qch and VirtualBox.qhc from $(vboxroot)/prebuild
 #  NOMODS=1         don't build any module
 #  NOQT=1           don't build the Qt GUI
@@ -44,11 +44,12 @@
 #  NOWEBSVC=1       don't build the webservice API, default for OSE
 #  STAGEDISO=<path> don't build the VBoxAdditions, use the precompiled .iso
-#  STAGEDCHM=<path> use VirtualBox*.chm from this directory
+#  STAGEDQHELP=<path> use VirtualBox*.qch and VirtualBox*.qhc from this directory
 #  PKGDIR=<path>    where to store the final package(s)
 #
 # NODOCS will be set if UserManual*.pdf is placed in $(vboxroot)/prebuild.
 # STAGEDISO will be set if VBoxGuestAdditions.iso is placed there.
-# STAGEDCHM will be set if VirtualBox*.chm is placed there.
-# VirtualBox*.chm is used if it is provided, but never attempted to be built.
+# STAGEDQHELP will be set if VirtualBox*.qch and VirtualBox*.qhc is placed there.
+# VirtualBox*.qch and VirtualBox*.qhc are used if they are provided, but never
+# attempted to be built.
 #
 # Wine will not be required if either NODOCS or STAGEDISO are set.
@@ -75,5 +76,5 @@
 NODOCS   ?= $(if $(wildcard $(vboxroot)/prebuild/UserManual*.pdf),1,)
 STAGEDISO ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxGuestAdditions.iso),$(vboxroot)/prebuild,)
-STAGEDCHM ?= $(if $(wildcard $(vboxroot)/prebuild/VirtualBox*.chm),$(vboxroot)/prebuild,)
+STAGEDQHELP ?= $(if $(and $(wildcard $(vboxroot)/prebuild/VirtualBox*.qch),$(wildcard $(vboxroot)/prebuild/VirtualBox*.qhc)),$(vboxroot)/prebuild,)
 NOWINE   := $(if $(NODOCS),1,$(if $(STAGEDISO),1,$(ose)))
 PYTHON   := $(firstword $(shell which python) $(shell which python3))
@@ -124,5 +125,5 @@
 	     VBOX_DO_STRIP= \
 	     VBOX_PATH_PACKAGE_DOCS="\"/usr/share/doc/$(verpkg)\"" \
-	     $(if $(STAGEDCHM),VBOX_WITH_DOCS_CHM=1,VBOX_WITH_KCHMVIEWER=) \
+	     $(if $(STAGEDQHELP),VBOX_WITH_DOCS_QHELP=1,) \
 	     VBOX_PACKAGE_DIST=$(debdist) \
 	     $(if $(svnrev),VBOX_SVN_REV=$(svnrev),) \
@@ -142,5 +143,5 @@
 	. debian/env.sh && kmk -C $(vboxroot) $(bld_flags) $(if $(NOPARALLEL),-j1,) all
 	$(if $(NODOCS),cp $(vboxroot)/prebuild/UserManual*.pdf $(builddir)/bin,)
-	$(if $(STAGEDCHM),cp $(STAGEDCHM)/VirtualBox*.chm $(builddir)/bin,)
+	$(if $(STAGEDQHELP),cp $(STAGEDQHELP)/VirtualBox*.qch $(STAGEDQHELP)/VirtualBox*.qhc $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI32.fd $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI64.fd $(builddir)/bin,)
@@ -260,7 +261,7 @@
 ifeq ($(ose),)
 	dh_installdocs \
-	    $(archdir)/UserManual*.pdf $(archdir)/VirtualBox*.chm \
-	    $(addprefix $(archdir)/, LICENSE)
-	rm $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.chm \
+	    $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.qch VirtualBox*.qhc \
+	    LICENSE)
+	rm $(addprefix $(archdir)/,UserManual*.pdf VirtualBox*.qch VirtualBox*.qhc \
 	    LICENSE)
 	for i in rdesktop-vrdp.tar.gz additions/VBoxGuestAdditions.iso; do \
@@ -339,5 +340,5 @@
 endif
 	$(firstword $(shell which dh_python2) $(shell which dh_python3))
-	dh_compress -X.pdf -X.chm -X LICENSE -X.py
+	dh_compress -X.pdf -X LICENSE -X.py
 	dh_fixperms
 	dh_makeshlibs
Index: trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec
===================================================================
--- trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 90037)
+++ trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 90038)
@@ -19,5 +19,5 @@
 %define %OSE% 1
 %define %PYTHON% 1
-%define %CHM% 1
+%define %QHELP% 1
 %define VBOXDOCDIR %{_defaultdocdir}/%NAME%
 %global __requires_exclude_from ^/usr/lib/virtualbox/VBoxPython.*$|^/usr/lib/python.*$|^.*\\.py$
@@ -192,5 +192,5 @@
 %{!?is_ose: mv LICENSE $RPM_BUILD_ROOT%{VBOXDOCDIR}}
 mv UserManual*.pdf $RPM_BUILD_ROOT%{VBOXDOCDIR}
-%{?with_chm: mv VirtualBox*.chm $RPM_BUILD_ROOT%{VBOXDOCDIR}}
+%{?with_qhelp: mv VirtualBox*.qch VirtualBox*.qhc $RPM_BUILD_ROOT%{VBOXDOCDIR}}
 install -m 755 -d $RPM_BUILD_ROOT/usr/lib/debug/usr/lib/virtualbox
 %if %{?rpm_suse:1}%{!?rpm_suse:0}
Index: trunk/src/VBox/Installer/linux/rpm/rules
===================================================================
--- trunk/src/VBox/Installer/linux/rpm/rules	(revision 90037)
+++ trunk/src/VBox/Installer/linux/rpm/rules	(revision 90038)
@@ -26,5 +26,5 @@
 #                   either the subversion rev [if available] or the build date)
 #  NODOCS=1         don't build docs, use precompiled UserManual.pdf and
-#                   maybe VirtualBox.chm from $(vboxroot)/prebuild
+#                   maybe VirtualBox.qch and VirtualBox.qhc from $(vboxroot)/prebuild
 #  NOMODS=1         don't build any module
 #  NOQT=1           don't build the Qt GUI
@@ -36,5 +36,5 @@
 #  NOWEBSVC=1       don't build the webservice API, default for OSE
 #  STAGEDISO=<path> don't build the VBoxAdditions, use the precompiled .iso
-#  STAGEDCHM=<path> use VirtualBox*.chm from this directory
+#  STAGEDQHELP=<path> use VirtualBox*.qch and VirtualBox*.qhc from this directory
 #  PKGDIR=<path>    where to store the final package(s)
 #  svn_revision=xxx do not depend on subversion being available, but use this
@@ -43,6 +43,7 @@
 # NODOCS will be set if UserManual*.pdf is placed in $(vboxroot)/prebuild.
 # STAGEDISO will be set if VBoxGuestAdditions.iso is placed there.
-# STAGEDCHM will be set if VirtualBox*.chm is placed there.
-# VirtualBox*.chm is used if it is provided, but never attempted to be built.
+# STAGEDQHELP will be set if VirtualBox*.qch and VirtualBox*.qhc is placed there.
+# VirtualBox*.qch and VirtualBox*.qhc are used if they are provided, but never
+# attempted to be built.
 #
 # Wine will not be required if either NODOCS or STAGEDISO are set.
@@ -71,5 +72,5 @@
 NODOCS   ?= $(if $(wildcard $(vboxroot)/prebuild/UserManual*.pdf),1,)
 STAGEDISO ?= $(if $(wildcard $(vboxroot)/prebuild/VBoxGuestAdditions.iso),$(vboxroot)/prebuild,)
-STAGEDCHM ?= $(if $(wildcard $(vboxroot)/prebuild/VirtualBox*.chm),$(vboxroot)/prebuild,)
+STAGEDQHELP ?= $(if $(and $(wildcard $(vboxroot)/prebuild/VirtualBox*.qch),$(wildcard $(vboxroot)/prebuild/VirtualBox*.qhc)),$(vboxroot)/prebuild,)
 NOWINE   := $(if $(NODOCS),1,$(if $(STAGEDISO),1,$(ose)))
 
@@ -183,5 +184,5 @@
 		$(wildcard /usr/bin/python2.6) $(wildcard /usr/bin/python2) $(wildcard /usr/bin/python))),) \
 	     $(doc_dir) \
-	     $(if $(STAGEDCHM),VBOX_WITH_DOCS_CHM=1,VBOX_WITH_KCHMVIEWER=) \
+	     $(if $(STAGEDQHELP),VBOX_WITH_DOCS_QHELP=1,) \
 	     VBOX_PACKAGE_DIST=$(rpmdist) \
 	     $(if $(svnrev),VBOX_SVN_REV=$(svnrev),) \
@@ -199,5 +200,5 @@
 	. $(bldbase)/env.sh && kmk -C $(vboxroot) $(bld_flags) $(if $(NOPARALLEL),-j1,) all
 	$(if $(NODOCS),cp $(vboxroot)/prebuild/UserManual*.pdf $(builddir)/bin,)
-	$(if $(STAGEDCHM),cp $(STAGEDCHM)/VirtualBox*.chm $(builddir)/bin,)
+	$(if $(STAGEDQHELP),cp $(STAGEDQHELP)/VirtualBox*.qch $(STAGEDQHELP)/VirtualBox*.qhc $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI32.fd $(builddir)/bin,)
 	$(if $(EFI),cp $(vboxroot)/prebuild/VBoxEFI64.fd $(builddir)/bin,)
@@ -239,5 +240,5 @@
 	    -e 's|%OSE%|$(if $(ose),is_ose,not_ose)|g' \
 	    -e 's|%SPEC%|$(rpmspec)|g' \
-	    -e 's|%CHM%|$(if $(STAGEDCHM),with_chm,without_chm)|g' \
+	    -e 's|%QHELP%|$(if $(STAGEDQHELP),with_qhelp,without_qhelp)|g' \
 	    -e 's|%PYTHON%|$(if $(filter el5,$(rpmrel)),without_python,with_python)|g' \
 	    -e 's|%MACROSPYTHON%|$(if $(wildcard /usr/lib/rpm/macros.d/macros.python3),,$(if $(wildcard /usr/lib/rpm/macros.python),%include /usr/lib/rpm/macros.python,))|g' \