Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.cpp	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.cpp	(revision 90066)
@@ -75,4 +75,5 @@
         m_pSpinBox->blockSignals(false);
     }
+    emit sigValueChanged(m_pSlider->value());
 }
 
@@ -85,4 +86,5 @@
         m_pSlider->blockSignals(false);
     }
+    emit sigValueChanged(m_pSpinBox->value());
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.h	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIVirtualCPUEditor.h	(revision 90066)
@@ -39,4 +39,8 @@
 {
     Q_OBJECT;
+
+ signals:
+
+    void sigValueChanged(int iValue);
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90066)
@@ -65,5 +65,5 @@
     , m_fSkipUnattendedInstall(false)
     , m_iCPUCount(1)
-    , m_iMemoryAmount(0)
+    , m_iMemorySize(0)
 
 {
@@ -771,12 +771,12 @@
 }
 
-int UIWizardNewVM::memoryAmount() const
-{
-    return m_iMemoryAmount;
-}
-
-void UIWizardNewVM::setMemoryCount(int iMemory)
-{
-    m_iMemoryAmount = iMemory;
+int UIWizardNewVM::memorySize() const
+{
+    return m_iMemorySize;
+}
+
+void UIWizardNewVM::setMemorySize(int iMemory)
+{
+    m_iMemorySize = iMemory;
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 90066)
@@ -30,8 +30,8 @@
 #include "CMedium.h"
 
-#define parentWizardSet(functionName, value)                         \
+#define newVMWizardPropertySet(functionName, value)                  \
     UIWizardNewVM *pWizard = qobject_cast<UIWizardNewVM*>(wizard()); \
-    if (pWizard)                                                     \
-        pWizard->functionName(value);
+    if (!pWizard)                                                    \
+        pWizard->set##functionName(value)
 
 /** Container for unattended install related data. */
@@ -137,6 +137,6 @@
     void setCPUCount(int iCPUCount);
 
-    int memoryAmount() const;
-    void setMemoryCount(int iMemory);
+    int memorySize() const;
+    void setMemorySize(int iMemory);
 
 protected:
@@ -208,5 +208,5 @@
 
     int m_iCPUCount;
-    int m_iMemoryAmount;
+    int m_iMemorySize;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp	(revision 90066)
@@ -40,5 +40,4 @@
     , m_pLabel(0)
 {
-    m_pWizard = qobject_cast<UIWizardNewVM*>(wizard());
     prepare();
     qRegisterMetaType<CMedium>();
@@ -59,7 +58,10 @@
 void UIWizardNewVMHardwarePageBasic::createConnections()
 {
-    connect(m_pBaseMemoryEditor, &UIBaseMemoryEditor::sigValueChanged,
-            this, &UIWizardNewVMHardwarePageBasic::sltMemoryAmountChanged);
-
+    if (m_pBaseMemoryEditor)
+        connect(m_pBaseMemoryEditor, &UIBaseMemoryEditor::sigValueChanged,
+                this, &UIWizardNewVMHardwarePageBasic::sltMemorySizeChanged);
+    if (m_pVirtualCPUEditor)
+        connect(m_pVirtualCPUEditor, &UIVirtualCPUEditor::sigValueChanged,
+            this, &UIWizardNewVMHardwarePageBasic::sltCPUCountChanged);
 
 }
@@ -125,11 +127,11 @@
 }
 
-void UIWizardNewVMHardwarePageBasic::sltMemoryAmountChanged(int iValue)
+void UIWizardNewVMHardwarePageBasic::sltMemorySizeChanged(int iValue)
 {
-    Q_UNUSED(iValue);
+    newVMWizardPropertySet(MemorySize, iValue);
 }
 
 void UIWizardNewVMHardwarePageBasic::sltCPUCountChanged(int iCount)
 {
-    Q_UNUSED(iCount);
+    newVMWizardPropertySet(CPUCount, iCount);
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h	(revision 90066)
@@ -61,5 +61,5 @@
 private slots:
 
-    void sltMemoryAmountChanged(int iValue);
+    void sltMemorySizeChanged(int iValue);
     void sltCPUCountChanged(int iCount);
 
@@ -75,6 +75,4 @@
     bool isComplete() const;
 
-    UIWizardNewVM *m_pWizard;
-
     /** @name Widgets
      * @{ */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90066)
@@ -481,5 +481,5 @@
 void UIWizardNewVMNameOSTypePageBasic::sltGuestOSFamilChanged(const QString &strGuestOSFamilyId)
 {
-    parentWizardSet(setGuestOSFamilyId, strGuestOSFamilyId);
+    newVMWizardPropertySet(GuestOSFamilyId, strGuestOSFamilyId);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90060)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90066)
@@ -179,5 +179,5 @@
 {
     disableEnableGAWidgets(fEnabled);
-    parentWizardSet(setInstallGuestAdditions, fEnabled);
+    newVMWizardPropertySet(InstallGuestAdditions, fEnabled);
     emit completeChanged();
 }
@@ -185,5 +185,5 @@
 void UIWizardNewVMUnattendedPageBasic::sltGAISOPathChanged(const QString &strPath)
 {
-    parentWizardSet(setGuestAdditionsISOPath, strPath);
+    newVMWizardPropertySet(GuestAdditionsISOPath, strPath);
     emit completeChanged();
 }
@@ -191,5 +191,5 @@
 void UIWizardNewVMUnattendedPageBasic::sltPasswordChanged(const QString &strPassword)
 {
-    parentWizardSet(setPassword, strPassword);
+    newVMWizardPropertySet(Password, strPassword);
     emit completeChanged();
 }
@@ -197,5 +197,5 @@
 void UIWizardNewVMUnattendedPageBasic::sltUserNameChanged(const QString &strUserName)
 {
-    parentWizardSet(setUserName, strUserName);
+    newVMWizardPropertySet(UserName, strUserName);
     emit completeChanged();
 }
@@ -211,15 +211,15 @@
 void UIWizardNewVMUnattendedPageBasic::sltHostnameChanged(const QString &strHostname)
 {
-    parentWizardSet(setHostname, strHostname);
+    newVMWizardPropertySet(Hostname, strHostname);
 }
 
 void UIWizardNewVMUnattendedPageBasic::sltProductKeyChanged(const QString &strProductKey)
 {
-    parentWizardSet(setProductKey, strProductKey);
+    newVMWizardPropertySet(ProductKey, strProductKey);
 }
 
 void UIWizardNewVMUnattendedPageBasic::sltStartHeadlessChanged(bool fStartHeadless)
 {
-    parentWizardSet(setStartHeadless, fStartHeadless);
+    newVMWizardPropertySet(StartHeadless, fStartHeadless);
 }
 